package fr.nitorac.aurionweb.update;

import android.content.Context;
import android.os.AsyncTask;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.JsonObject;

import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.ref.WeakReference;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;

import fr.nitorac.aurionweb.BuildConfig;

public class AsyncUpdateCheckerTask extends AsyncTask<Void, Void, JsonObject> {

    private WeakReference<Context> weakContext;

    public AsyncUpdateCheckerTask(Context c){
        weakContext = new WeakReference<>(c);
    }

    @Override
    protected JsonObject doInBackground(Void... voids) {
        try {
            URL url = new URL(UpdateManager.CHECK_URL + URLEncoder.encode(BuildConfig.VERSION_NAME, StandardCharsets.UTF_8.toString()));
            HttpURLConnection conn=(HttpURLConnection) url.openConnection();
            conn.setConnectTimeout(10000); // timing out in a minute

            JsonObject obj = new Gson().fromJson(new InputStreamReader(conn.getInputStream()), JsonObject.class);
            if(!obj.get("version").getAsString().equalsIgnoreCase(BuildConfig.VERSION_NAME)){
                return obj;
            }else{
                return new JsonObject();
            }
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    protected void onPostExecute(JsonObject obj) {
        super.onPostExecute(obj);
        if(weakContext == null){
            return;
        }
        if(obj == null){
            Toast.makeText(weakContext.get(), "Impossible de vérifier les mises à jour ...", Toast.LENGTH_SHORT).show();
        }else if(!obj.entrySet().isEmpty()){
            UpdateManager.updateAvailable = true;
            UpdateManager.getInstance().spawnUpdateDialog(weakContext, obj);
        }
    }
}
